-- name: [CS] Meggy Spletzer
-- description: Splatfest Champ, former Inkling, bad cook, whatever you'd like to call her, Meggy Spletzer makes her appearance in SM64, as she helps Mario and friends defeat the great Bowser!\n\n\Modpack by VioletArts\n\n\Meggy Spletzer belongs to SMG4 and Glitch Productions
-- deluxe: true
local globalModName = "Meggy Spletzer";

local E_MEGGY_MODEL = smlua_model_util_get_id("meggy_violet_geo");
local MEGGY_CAPMODELS = {
normal = smlua_model_util_get_id("meggy_violet_cap_geo"),
wing = smlua_model_util_get_id("meggy_violet_cap_wing_geo"),
metal = smlua_model_util_get_id("meggy_violet_cap_metal_geo"),
metalWing = smlua_model_util_get_id("meggy_violet_cap_metal_wing_geo"),
}
local MEGGY_DESC = {"Splatfest Champ, former Inkling, bad cook, whatever", "you'd like to call her, Meggy Spletzer makes her", "appearance in SM64, as she helps Mario and friends", "defeat the great Bowser!", ""}
local MEGGY_SELECTCOLOR = {r = 255, g = 144, b = 53}
local MEGGY_PALETTE = {
[PANTS] = "494949",
[SHIRT] = "FFFFFF",
[GLOVES] = "525A4C",
[SHOES] = "503325",
[HAIR] = "FF9035",
[SKIN] = "FFBF8D",
[CAP] = "E4302A",
[EMBLEM] = "7C8D6F"
}

local VOICETABLE_CHAR = {
    [CHAR_SOUND_ATTACKED] = 'MeggyAttacked.ogg',
    [CHAR_SOUND_COUGHING3] = 'MeggyCough.ogg',
    [CHAR_SOUND_DOH] = 'MeggyDoh.ogg',
    [CHAR_SOUND_DROWNING] = 'MeggyDrown.ogg',
    [CHAR_SOUND_DYING] = 'MeggyDead.ogg',
    [CHAR_SOUND_EEUH] = 'MeggyEeuh.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'MeggyGroundPound.ogg',
    [CHAR_SOUND_HAHA] = 'MeggyHaha.ogg',
    [CHAR_SOUND_HAHA_2] = 'MeggyHaha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'MeggyWoomy.ogg',
    [CHAR_SOUND_HOOHOO] = 'MeggyYahaJump.ogg',
    [CHAR_SOUND_HRMM] = 'MeggyGrab.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'MeggyTired.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'MeggyLetsDoThis.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'MeggyComeOn.ogg',
    [CHAR_SOUND_ON_FIRE] = 'MeggyBurning.ogg',
    [CHAR_SOUND_OOOF] = 'MeggyOof.ogg',
    [CHAR_SOUND_OOOF2] = 'MeggyOof.ogg',
    [CHAR_SOUND_PANTING] = 'MeggyPanting.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'MeggyPanting.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'MeggyHooKick.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'MeggyWahPunch.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'MeggyYahPunch.ogg',
    [CHAR_SOUND_SNORING1] = 'MeggySnore1.ogg',
    [CHAR_SOUND_SNORING2] = 'MeggySnore2.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'MeggyBowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'MeggyBoing.ogg',
    [CHAR_SOUND_UH] = 'MeggyUh.ogg',
    [CHAR_SOUND_UH2] = 'MeggyUh.ogg',
    [CHAR_SOUND_UH2_2] = 'MeggyUh.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'MeggyYell.ogg',
    [CHAR_SOUND_WHOA] = 'MeggyWoah.ogg',
    [CHAR_SOUND_YAHOO] = 'MeggyYahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'MeggyYahoo.ogg', 'MeggyWaha.ogg', 'MeggyYippee.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'MeggyYahJump.ogg', 'MeggyWahJump.ogg', 'MeggyHooJump.ogg'},
    [CHAR_SOUND_YAWNING] = 'MeggyYawn.ogg',
}

if _G.charSelectExists and SM64COOPDX_VERSION then
    local curVers = _G.charSelect.version_get();
     if not tonumber(curVers) then
        curVers = string.gsub(curVers, "[%a%s_()!?:,@#-]+", "");
                
        curVers = curVers:gsub("%.", "X", 1):gsub("%.", ""):gsub("X", ".");
    end
    curVers = tonumber(curVers);

table.insert(MEGGY_DESC, "Voice by SaltedPearls");
table.insert(MEGGY_DESC, "Model by VioletArts");

local charNum = _G.charSelect.character_add("Meggy Spletzer", MEGGY_DESC, "VioletArts", MEGGY_SELECTCOLOR, E_MEGGY_MODEL, CT_MARIO, get_texture_info("meggy_violet_icon")); -- adds the character to CS. change that _skl part
_G.charSelect.character_add_caps(E_MEGGY_MODEL, MEGGY_CAPMODELS);

if curVers >= 1.8 then -- adds palette preset if 1.8 or above
_G.charSelect.character_add_palette_preset(E_MEGGY_MODEL, MEGGY_PALETTE);
end
--[[if curVers > 1.8 then -- adds custom health meter if above 1.8
_G.charSelect.character_add_health_meter(charNum, healthHUDTex);
end]]

_G.charSelect.character_add_voice(E_MEGGY_MODEL, VOICETABLE_CHAR)
hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
    if _G.charSelect.character_get_voice(m) == VOICETABLE_CHAR then return _G.charSelect.voice.sound(m, sound) end
end)
hook_event(HOOK_MARIO_UPDATE, function (m)
    if _G.charSelect.character_get_voice(m) == VOICETABLE_CHAR then return _G.charSelect.voice.snore(m) end
end)
else
    djui_popup_create("\\#ffffdc\\\n"..globalModName.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end